﻿@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using Portal.Models.Forecast;
@using DevExpress.Utils;
@Html.DevExpress().GridView(
                    setting =>
                    {
                        setting.Name = "GridLogHeader";
                        setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
                        setting.Width = Unit.Percentage(80);
                        setting.KeyFieldName = "ProcessID";
                        setting.SettingsDetail.MasterGridName = "grid";

                        setting.SettingsPager.PageSizeItemSettings.Visible = true;
                        setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
                        setting.SettingsPager.PageSizeItemSettings.Caption = "Page size";
                        setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Hidden;
                        setting.SettingsPager.FirstPageButton.Visible = true;
                        setting.SettingsPager.LastPageButton.Visible = true;
                        setting.CallbackRouteValues = new { Controller = "LogMonitoring", Action = "ReloadGrid" };
                        setting.ClientSideEvents.BeginCallback = "BeginGridCallback";
                        //setting.ClientSideEvents.EndCallback = "OnDetailGridEndCallback";

                        //var detailsColumn = setting.Columns.Add("", "Detail");
                        //detailsColumn.Width = Unit.Pixel(30);
                        //detailsColumn.SetDataItemTemplateContent(c =>
                        //{
                        //    //setting.Settings.VerticalScrollableHeight = 250;
                        //    setting.SettingsDetail.AllowOnlyOneMasterRowExpanded = true;
                        //    setting.SettingsDetail.ShowDetailRow = true;

                        //});

                        //setting.Columns.Add("ProcessID", "Process ID", MVCxGridViewColumnType.TextBox).Width = Unit.Pixel(50);
                        //setting.Columns["ProcessID"].CellStyle.HorizontalAlign = HorizontalAlign.Center;

                        setting.Columns.Add(col =>
                        {
                            col.FieldName = "ProcessID";
                            col.Caption = "Process ID";
                            col.Width = 75;
                            col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                            col.SetDataItemTemplateContent(container =>
                            {
                                Html.DevExpress().HyperLink(hlSettings =>
                                {
                                    hlSettings.Name = string.Format("hl_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                                    hlSettings.NavigateUrl = "javascript:void(0)";
                                    //hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OnHyperLinkClick('{0}'); }}", (container as GridViewDataItemTemplateContainer).Text);

                                    //hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ ShowLogDetailData('{0}'); }}", (container as GridViewDataItemTemplateContainer).Text);
                                    hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ ShowLogDetailData('{0}', '{1}', '{2}', '{3}', '{4}', '{5}', '{6}'); }}", DataBinder.Eval(container.DataItem, "ProcessID"), DataBinder.Eval(container.DataItem, "FunctionID"), DataBinder.Eval(container.DataItem, "FunctionNM"), DataBinder.Eval(container.DataItem, "ProcessDate"), DataBinder.Eval(container.DataItem, "EndDate"), DataBinder.Eval(container.DataItem, "ProcessStatus"), DataBinder.Eval(container.DataItem, "UserID"));

                                    hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;




                                }).Render();
                            });
                        });

                        setting.Columns.Add("FunctionID", "Function ID", MVCxGridViewColumnType.TextBox).Width = Unit.Pixel(80);
                        setting.Columns["FunctionID"].CellStyle.HorizontalAlign = HorizontalAlign.Center;

                        setting.Columns.Add("FunctionNM", "Function Name", MVCxGridViewColumnType.TextBox).Width = Unit.Pixel(150);
                        setting.Columns["FunctionNM"].CellStyle.HorizontalAlign = HorizontalAlign.Left;



                        setting.Columns.AddBand(
                            columnBand =>
                            {
                                columnBand.Caption = "Process Date";
                                columnBand.Columns.Add(
                                    column =>
                                    {
                                        column.Caption = "Start";
                                        column.Name = "datefrom";
                                        column.FieldName = "ProcessDate";
                                        column.Width = Unit.Pixel(80);
                                        column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                                        column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";

                                    }
                                 );

                                columnBand.Columns.Add(
                                    column =>
                                    {
                                        column.Caption = "Finish";
                                        column.Name = "enddate";
                                        column.FieldName = "EndDate";
                                        column.Width = Unit.Pixel(80);
                                        column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                                        column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy HH:mm:ss";

                                    }
                                    );

                            }
                            );

                        setting.Columns.Add("UserID", "User ID", MVCxGridViewColumnType.TextBox).Width = Unit.Pixel(80);
                        setting.Columns["UserID"].CellStyle.HorizontalAlign = HorizontalAlign.Center;


                        //setting.Columns.Add("ProcessDate", "Process Date", MVCxGridViewColumnType.TextBox).Width = Unit.Pixel(100);
                        //setting.Columns["ProcessDate"].CellStyle.HorizontalAlign = HorizontalAlign.Center;

                        //setting.Columns.Add("ProcessStatus", "Status", MVCxGridViewColumnType.TextBox).Width = Unit.Pixel(75);
                        //setting.Columns["ProcessStatus"].CellStyle.HorizontalAlign = HorizontalAlign.Left;
                        setting.Columns.Add(
                   column =>
                   {
                       column.Name = "Status";
                       column.FieldName = "ProcessStatus";
                       column.Caption = "Process Status";

                       column.Width = Unit.Pixel(80);
                       column.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                       column.CellStyle.VerticalAlign = VerticalAlign.Middle;

                       /*
                       column.SetDataItemTemplateContent(
                           content =>
                           {
                               Html.DevExpress().Label(
                                   label =>
                                   {
                                       label.Name = "ProsesStatusLabel" + content.VisibleIndex;
                                       label.ControlStyle.HorizontalAlign = HorizontalAlign.Center;
                                       label.ControlStyle.VerticalAlign = VerticalAlign.Middle;
                                       object dataItem = DataBinder.Eval(content.DataItem, "ProcessStatus");

                                       if (dataItem != null)
                                       {
                                           switch (Convert.ToString(dataItem))
                                           {
                                               case "Success":
                                                   label.Text = "Success";
                                                   break;
                                               case "Error":
                                                   label.Text = "Error";
                                                   break;  
                                               default :
                                                   label.Text = "Completed with Error";
                                                   break;                                       
                                           }
                                       }
                                       else
                                       {
                                           label.Text = "";
                                       }

                                   }).Render();
                           }); */

                   });

                        //setting.SettingsDetail.AllowOnlyOneMasterRowExpanded = true;
                        //setting.SettingsDetail.ShowDetailRow = true;
                        //setting.SetDetailRowTemplateContent(
                        //c =>
                        //{
                        //    Html.RenderAction("LogMonitoringDetails", new { id = DataBinder.Eval(c.DataItem, "ProcessID") });
                        //});
                    }).Bind(Model.GetModel<Portal.Models.LogMonitoring.LogMonitoringModel>().LogMonitoring).GetHtml()